/*
* Writes the Value of the RFID Tag to a file named currenttag.txt.  If a tag is removed from the range of the read
* it wil print 'Tag out of Range' on the command terminal.
*/

#include <stdio.h>
#include <phidget21.h>
#include <unistd.h>

int key;
int buf;
int gettag (CPhidgetRFIDHandle rfid, void *key, unsigned char *buf)

{

FILE* outfile;

outfile = fopen("currenttag","w");
fprintf(outfile, "%x%x%x%x%x%x%x%x%x%x\n", buf[0]/16,buf[0]%16,buf[1]/16,buf[1]%16,buf[2]/16,buf[2]%16,buf[3]/16,buf[3]%16,buf[4]/16,buf[4]%16);



 
fclose(outfile);
return 0;
}

int losttag (CPhidgetRFIDHandle rfid, void *key, unsigned char *buf)
{

printf("Tag out of range\n");

return 0;
}

int main(int argc, const char * argv[]) 
{

const char* type;	
int dev; 	

	long status =0;
	
	
	CPhidgetRFIDHandle rfid = 0;
	CPhidgetRFID_create(&rfid);
	CPhidget_open((CPhidgetHandle)rfid,-1);
	
	CPhidget_waitForAttachment((CPhidgetHandle)rfid, 0);
	
	CPhidget_getDeviceVersion((CPhidgetHandle)rfid, &dev);
	CPhidget_getDeviceType((CPhidgetHandle)rfid, &type);
	
	printf("%10s, Device Version:  %d, \n", type, dev);

	CPhidgetRFID_setAntennaOn (rfid, 1);
	

while (1)
{

	CPhidgetRFID_set_OnTag_Handler(rfid, &gettag, NULL);
	CPhidgetRFID_set_OnTagLost_Handler(rfid, &losttag, NULL);
	
	sleep(1);
}	


	
	  return 0;
}
